<template>
  <div>
    <h1>Here we do some searching!</h1>
    <LatLngSearch :trigger="setLocation" :currentLocation="this.$store.getters.getUserLocation"/>
    <SearchAutocomplete :suggestions="this.$store.getters.getSearchResults"
                        :trigger="search"
                        :onSelected="onSelected"/>
    <Modal v-show="isModalVisible" :close="onClose">
      <template v-slot:body>
        <h2>{{ selected.name }}</h2>
        <strong>Distance:</strong>
        <p>{{ selected.distance }}</p>
        <strong>Score:</strong>
        <p>{{ selected.score }}</p>
      </template>
    </Modal>
  </div>
</template>
<script lang="ts">
import Vue from 'vue';
import SearchAutocomplete from '@/components/SearchAutocomplete.vue';
import LatLngSearch from '@/components/LatLngSearch.vue';
import Modal from '@/components/Modal.vue';
import CONSTANTS from '../utils/constants';
import { SearchEntry } from '../../../models/SearchEntry.model';
import { LatLng } from '../../../models/LatLng.model';

export default Vue.extend({
  name: 'SearchView',
  components: { SearchAutocomplete, Modal, LatLngSearch },
  data() {
    return {
      isModalVisible: false,
      selected: {} as SearchEntry,
    };
  },
  mounted() {
    // Start listen to socket returning search results.
    this.$store.dispatch(CONSTANTS.store.LISTEN_SEARCH_RESULTS);
  },
  methods: {
    search(search: string): void {
      // trigger search
      this.$store.dispatch(CONSTANTS.store.SET_SEARCH_VARIABLE, search);
    },
    setLocation(Location: LatLng): void {
      this.$store.dispatch(CONSTANTS.store.SET_SEARCH_LOCATION, Location);
    },
    onSelected(selected: SearchEntry): void {
      this.selected = selected;
      this.isModalVisible = true;
    },
    onClose(): void {
      this.isModalVisible = false;
    },
  },
});
</script>
<style>
</style>
